#!/usr/bin/python
#
# Copyright (c) 2005, Reinhard Tartler, Stefan Potyra 
#
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
# 
#     * Redistributions of source code must retain the above copyright notice,
#     this list of conditions and the following disclaimer.
# 
#     * Redistributions in binary form must reproduce the above copyright
#     notice, this list of conditions and the following disclaimer in the
#     documentation and/or other materials provided with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#

from optparse import OptionParser
from Config import Config

def alter_level(email, level):
        print "Altering %s to level %s" % (email, level)
	cfg = Config()
        c = cfg.getConnection()
        sql = "UPDATE Users SET accesslevel = '%s' WHERE email = '%s'" % (level.title(), email)
        c.query(sql)

def alter_password(email, passwd):
        print "Altering password of %s to %s" % (email, passwd)
	cfg = Config()
        c = cfg.getConnection()
        sql = "UPDATE Users SET password = '%s' WHERE email = '%s'" % (passwd, email)
        c.query(sql)

def show_password(c, email):
	sql = "SELECT password FROM Users WHERE email = '%s'" % email
	r = c.query(sql)
	if r.ntuples() == 1:
		return r.getresult()[0][0]
	else:
		return None

if __name__ == '__main__':
        usage = "usage: %prog [options]"
        parser = OptionParser(usage)
        parser.add_option("-e", "--email", dest="email",
                          help="Email (==login) of user to alter")
        parser.add_option("-l", "--level", dest="level", type="choice",
                          choices = ['contributor', 'reviewer', 'admin'],
                          help="0 = contributor, 1 = reviewer, 2 = admin")
        parser.add_option("-p", "--password", dest="passwd",
                          help="new password for user")
        parser.add_option("-s", "--show-password", dest="showpw", action="store_true",
			  help="show password of user")

        (options, args) = parser.parse_args()
        if options.email is None:
                parser.print_help()
                parser.error("you must specify user to alter")

        if options.level is not None:
                alter_level(options.email, options.level)
        if options.passwd is not None:
                alter_password(options.email, options.passwd)
	if options.showpw:
		cfg = Config()
		print show_password(cfg.getConnection(), options.email)
